         PRINT NOGEN
STATLINE DSECT
STATLEN  DC    AL1(0)
ISNAME   DS    CL3'IS-'                                                 f4229
ISNUM    DC    CL2' '                                                   f4229
         DC    CL3''                                                    f4229
ISSTAT   DS    CL7' '         ACTIVE,INACT, or UNDEF                    f4229
         ORG   ,
         BEGIN NAME=QIP0,IBM=YES                  CREATED    08/26/86
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          Copyright IBM Corp. 2005, 2006                             *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  D14317   20060420   CTL-B happens when ZTEST SIPC LARGE 5 is       *
*                      entered.                                       *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*   MODULE NAME = SEE BELOW                                           *
*                                                                     *
*        SOURCE MODULE NAME =  QIP0, ORGINAL VERSION OF SIPC          *
*                                                                     *
*        OBJECT MODULE NAME =  QIP0                                   *
*                                                                     *
*        RELATED MODULE NAME =                                        *
*                                                                     *
*   DESCRIPTIVE NAME = IPC TEST DRIVER                                *
*                                                                     *
*   STATUS = VERSION 2  MODIFICATION 3                                *
*                                                                     *
* FUNCTION=                                                           *
*                                                                     *
*  SIPC IS ABLE TO PROVIDE THE FOLLOWING FUNCTIONS:                   *
*                                                                     *
*  1. TO TEST THE IPC PATH BETWEEN ANY TWO PROCESSORS IN A LOOSELY-   *
*     COUPLED ENVIRONMENT.                                            *
*                                                                     *
*  2. TO VERIFY THE SEQUENCE OF BLOCKS SENT VIA A SIPC ARRIVE IN      *
*     CORRECT SEQUENCE.                                               *
*                                                                     *
*  3. TO TEST THE INTER-ISTREAM COMMUNICATION BETWEEN ANY TWO OR MORE *
*     I-STREAMS.                                                      *
*                                                                     *
***********************************************************************
         EJECT ,
***********************************************************************
*                                                                     *
*  ZTEST SIPC START  <ALL>       - START DRIVER                       *
*                                                                     *
*  ZTEST SIPC STOP   <ALL>       - STOP DRIVER                        *
*                                                                     *
*  ZTEST SIPC STATUS <ALL>       - QUERY STATUS OF DRIVER             *
*                                                                     *
*  ZTEST SIPC SPEED <1..9> <ALL> - ALTER SPEED OF DRIVER              *
*                                                                     *
*  ZTEST SIPC S|L|4  <1..8>      - FCT MODE WITH ERROR PATH OPTIONS   *
*                                                                     *
*  ZTEST SIPC ?  (HELP)          - HELP MESSAGE                       *
*                                                                     *
*  Register Conventions:  They're marked in each subroutine where it  *
*  is deemed necessary due to code complexity.                        *
*                                                                     *
*  ECB conventions:  The ECB workareas are used as follows:           *
*                                                                     *
*  EBX000 - SI3CT Dsect or I-S number workarea                        *
*     loc   len    field                                              *
*    EBX000  1  - SI3DSTN or I-S number                               *
*    EBX001  1  - SI3ORIG or SI3ACT or SI3PROC                        *
*    EBX002  1  - SI3FLGS                                             *
*    EBX003  1  - SI3FLGU                                             *
*    EBX004  1  - SI3RESD                                             *
*    EBX005  1  - SI3LEN1                                             *
*    EBX006  2  - SI3LEN2                                             *
*    EBX008  24 - SIPC control area                                   *
*                                                                     *
*  EBX032 - Parameter equates                                         *
*     loc   len    field                                              *
*    EBX032  4  - FUNCTEST                                            *
*    EBX036  8  - NAME1                                               *
*    EBX044  8  - NAME2                                               *
*    EBX052  4  - ROUTE                                               *
*                                                                     *
*  EBX056    Unused                                                   *
*     loc   len    field                                              *
*    EBX056  1  - UNUSED                                              *
*    EBX057  1  - UNUSED                                              *
*                                                                     *
*  EBX058    1  - ERRORIND                                            *
*  EBX059    1  - TRANLIST                                            *
*                                                                     *
*  EBX060    1  - UNUSED                                              *
*                                                                     *
*  EBX061-EBX063 - Reserved                                           *
*                                                                     *
*  EBX064 - EV0BK Dsect                                               *
*     loc   len    field                                              *
*    EBX064  8  - EVNBKN                                              *
*    EBX072  2  - EVNBKC1 or EVNBKM1                                  *
*    EBX074  2  - EVNBKM2                                             *
*    EBX076  1  - EVNBKE                                              *
*    EBX077  3  - Unused                                              *
*                                                                     *
*  EBX080 - EV0BK Dsect                                               *
*     loc   len    field                                              *
*    EBX080  8  - EVNBKN                                              *
*    EBX088  2  - EVNBKC1 or EVNBKM1                                  *
*    EBX090  2  - EVNBKM2                                             *
*    EBX092  1  - EVNBKE                                              *
*    EBX093  3  - Unused                                              *
*                                                                     *
*  EBX096 - Global Area Base or Status MSG count                      *
*                                                                     *
*                                                                     *
*  EBW000 - UNPK instruction workarea or CREx paramters               *
*     loc   len    field                                              *
*    EBW000  8  - UNPK workarea   or                                  *
*                                                                     *
*    EBW000  1  - Character 'C' if a CRET                             *
*    EBW001  3  - LNIATA if a CRET or                                 *
*                                                                     *
*    EBW000  4  - STAR, STOP, STAT or SPEE parameter if a CREM        *
*    EBW004  3  - LNIATA if a CREM                                    *
*    EBW007  1  - CE1CPD if a CREM                                    *
*                                                                     *
***********************************************************************
         CZ1CP                                                 DRV
         SPACE 1
         PI1DT REG=R14                set up dsect
         EV0BK                        declare dsect
         USING EV0BK,R3               x                        @32LCIPC
         BAS   R5,CREATE_LIST         do list setup            @32LCIPC
         SPACE 1
***********************************************************************
* HOWENTER will determine how this segment was entered and for what   *
* reason.  If a core block is evident on D0 then we were entered from *
* a Zmsg and parameter parsing must be done.  If not then we know     *
* some CRExC macro was used and we have to re-justify CE1CPD and      *
* EBROUT.                                                             *
***********************************************************************
HOWENTER DS    0H                    det how we were entered  TD00323
         SYSTC SBSDPS,IFOFF=NOTLC    is this an HPO system?   TD00323
         CLC   CE1CR0(4),ZEROS       basically - is a block held?
         BNE   DETPARMS              yes - determine params
         CLI   CRETPARM,CRET         is result of our cret?   TD00326
         BE    SYSTEST               yes ... else next lines for crem
         MVC   CE1CPD,WHATPROC       justify cpd for sipc all TD00326
         MVC   EBROUT,LNIATA2        move in passed ebrout    TD00326
         B     SYSTEST
         EJECT ,
***********************************************************************
* DETPARMS knows that we were entered as a result of a Zmsg.  Now we  *
* need to determine whether it is a FTM start, with or without error  *
* path, or a STM caller parsing must be done.                         *
***********************************************************************
DETPARMS DS    0H
         CINFC R,CMMPID              get pidt in r14           @32LCIPC
         MVC   CE1CPD,PI1CPUI        Set CE1CPD to match CPU-ID
*                                    of this processor
         L     R1,CE1CR0             POINT TO INPUT MSG LIST
         LA    R1,CM1PAR(,R1)        LOAD ADDR OF INPUT MSG
         BAS   R5,LOOKAHED           STRIP OFF LEADING BLANKS
         CLC   =C'?',0(R1)           help requested?
         BE    NEEDHELP              yes - call needhelp
         CLC   =C'SM',0(R1)          small parameter?
         BE    ONESHOT               yes - call one shot
         CLC   =C'LA',0(R1)          large parameter?
         BE    ONESHOT               yes - call one shot
         CLC   =C'4K',0(R1)          4k parameter?
         BE    ONESHOT               yes - call one shot
***********************************************************************
* Only valid parameters at this point can be start, stop, or status,  *
* possibly followed by an 'all' or speed follwed by a number 1 thru 9.*
***********************************************************************
         MVC   PARMWORD,0(R1)        copy the first four characters
         CLI   PARMWORD,C'S'         if valid then begin with s
         BNE   BADPARAM              not valid
         CLC   =C'SPEE',0(R1)        speed control?
         BNE   NOTSPEED              no
         BAS   R5,SKIPCHAR           strip speed
         BAS   R5,LOOKAHED           strip blanks
         CLI   0(R1),C'1'            is it a one?
         BL    INVNUM                too low
         CLI   0(R1),C'9'            is it a nine?
         BH    INVNUM                too high
         CLI   1(R1),ENDOFMSG        is this a return?                  d13507
         BE    VALIDNUM              ok, it's a valid num               d13507
         CLI   1(R1),BLANK           Is this a blank?                   d13507
         BNE   INVNUM                it's a value larger than 9         d13507
VALIDNUM DS    0H                                                       d13507
         MVC   EBW008,0(R1)          move it
         NI    EBW008,X'0F'          turn off fox, leave num on
NOTSPEED DS    0H
         BAS   R5,SKIPCHAR           skip all if any chars
         BAS   R5,LOOKAHED           strip blanks
         CLC   =C'ALL',0(R1)         was all coded?
         BE    CEBICLP               yes - goto cebic loop
         B     SYSTEST               else goto systest to det ebw000
         EJECT ,
***********************************************************************
* This procedure deals with the function test environment.  We must   *
* set an ECB flag indicating a one-shot, set the proper block type    *
* counter and call SIPCLOOP.  Processing is extremely simple.         *
*                                                                     *
* REGS - R1 - Address of input parameters.                            *
*        R4 - Blocktype counter - counter A in logic specs            *
***********************************************************************
ONESHOT  DS    0H
         MVI   FUNCTEST,FTLEVEL       set indicator saying it is 1shot
         CLI   0(R1),C'S'             small parameter?
         BE    SMALL                  yes - handle it
         BL    LARGE                  if less then large - handle it
         L     R4,THREE               must be 4k if we're here
         B     SIPCLOOP               lets go send the sipc
SMALL    DS    0H
         L     R4,ONE                 move indicator for small block
         B     SIPCLOOP               lets go send the sipc
LARGE    DS    0H
         L     R4,TWO                 move indicator for large block
         B     SIPCLOOP               lets go send the sipc
         EJECT ,
***********************************************************************
* This procedure is called if the paramters indicate we are in a      *
* system test environment.  It will determine the parameter passed    *
* and will act accordinly.                                            *
*                                                                     *
* Register Conventions:                                               *
*   R2 - Will contain the name of the SSU                             *
*   R4 - Blocktype counter                                            *
*   R5 - Branching                                                    *
*   R6 - A counter to be used to indicate number of sipc's sent       *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of PARMS dsect                                     *
*   EBW000 - Where 4 significant characters of input parameter is     *
*                                                                     *
***********************************************************************
SYSTEST  DS    0H
         GLOBZ REGR=R6                lets get a hold of the globals
         L     R7,@ISUDRV
         UD0RV REG=R7                 we can now access it forever
         ST    R7,GLBLSAVE            save the base for later
         CLI   CRETPARM,C'C'           is it result of a cret?
         BE    CRETBEG                yes - handle
         CLC   =C'STAT',PARMWORD       is it stat?
         BE    STATUS                 yes - handle
         CLC   =C'STOP',PARMWORD       is it stop?
         BE    STOP                   yes - handle
         CLC   =C'STAR',PARMWORD       is it start?
         BE    START                  yes - handle
         CLC   =C'SPEE',PARMWORD       is it speed?
         BE    SPEED                  yes - handle
         B     BADPARAM               must be bad parameters
SPEED    DS    0H
         MVC   UD0SIPC+1(1),EBW008    move the new second time up there
         B     NEWCRET                write a message
STATUS   DS    0H
         BAS   R5,CHECKRUN            find if we are running
         B     STATMSG
STOP     DS    0H
         BAS   R5,CHECKRUN            find if we are running
         GLMOD GLOBAL1                set key
         NI    @SWITCH,X'FB'          turn off bit
         KEYRC                        reset key
         MVI   UD0SIPC,STOPRUN        set global off
         B     STOPMSG
START    DS    0H
         BAS   R5,CHECKRUN            find if we are running
         GLMOD GLOBAL1                set key
         OI    @SWITCH,X'04'          turn on bit
         KEYRC                        reset key
         MVI   UD0SIPC,RUNNIN         set global on
         MVC   UD0SIPC+2(2),ZEROS     set counter to zero
         BAS   R5,STARTED             write a msg saying we started
         B     STRTSTF
CRETBEG  DS    0H
         MVC   EBROUT,LNIATA1         move ebrout passed
STRTSTF  DS    0H
         MVI   FUNCTEST,STLEVEL       set indicator for systest
         L     R4,ONE                 set indicator for 381 byte blck
         B     SIPCLOOP
         EJECT ,
***********************************************************************
* This procedure sends the actual SIPC.  It will create the events    *
* and will determine what block size to send.  If will also perpetuate*
* itself if the global indicators says to.                            *
*                                                                     *
* Register Conventions:                                               *
*   R1 - Pointers to the first of the 2 EV0BK Dsects                  *
*   R2 - Points to the block to be passeds' core level.               *
*   R4 - A block type counter.                                        *
*   R5 - Branching and scratch                                        *
*   R6 - Base Address of parameter list, SI3CT                        *
*   R7 - Global area base address                                     *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of SI3CT dsect                                     *
*   EBX032 - Start of PARMS dsect                                     *
*   EBX064 - Start of EV0BK dsect for event 1                         *
*   EBX080 - Start of EV0BK dsect for event 2                         *
*                                                                     *
***********************************************************************
SIPCLOOP DS    0H
         MVI   ERRORIND,NOERROR       set this to no error at all
         CLI   FUNCTEST,FTLEVEL       function test mode?
         BNE   DETBLOCK               no - determine block to use
         BAS   R2,SETUPERR            yes - setup error
***********************************************************************
* This will determine what size data block to get on D2 based on the  *
* value in R4.                                                        *
***********************************************************************
DETBLOCK DS    0H
         C     R4,TWO                 1055 byte block?
         BE    GETLARGE               yes handle it
         BL    GETSMALL               yes - handle it
         GETCC D2,L4                  get 4k byte block
         B     GETEVNTS               lets create some events
GETSMALL DS    0H
         GETCC D2,L1                  get 381 byte block
         B     GETEVNTS               lets create some events
GETLARGE DS    0H
         GETCC D2,L2                  get 1055 byte block
***********************************************************************
* This will enter a routine to fill the block with data and create    *
* the events needed for running.  Event 1 is for the SIPC, 2 is for   *
* the ERROR/NORMAL return given from the IPC mechanism, and 3 is for  *
* the receiving processor to wait on for all I-Streams to finish any  *
* processing.  CE1CPD and EBROUT are added to the passed parameters.  *
***********************************************************************
GETEVNTS DS    0H
         BAS   R5,FILLBLK             fill block with data
         MVC   ROUTE(3),EBROUT        get ebrout to parms
         MVC   ROUTE+3(1),CE1CPD      get cpu id
         L     R3,CE1CR1              load base of list block  @32LCIPC
         EVNTC TYPE=LIST,                                              X
               BLOCK=(R3),                                             X
               NAME=N,                                                 X
               STATE=1052                                      @32LCIPC
         MVC   NAME1,EVNBKN           move event 1's name
         SPACE ,
         L     R3,CE1CR3              base of second list      @32LCIPC
         EVNTC TYPE=LIST,                                              X
               BLOCK=(R3),                                             X
               NAME=N,                                                 X
               STATE=1052                                      @32LCIPC
         MVC   NAME2,EVNBKN           move event 2's name      @32LCIPC
**********************************************************************
* Next few lines create 'event3' name for QIP1's use.                *
**********************************************************************
         L     R5,CE1CR2              addr of block          TD00323
         MVC   0(8,R5),NAME1          copy name1             TD00323
         MVC   0(2,R5),CE1SSU         prepend ssu            TD00323
         MVC   2(2,R5),CE1ISN         prepend istream number TD00323
**********************************************************************
*  At this point 3 events are created and all parameters are set up  *
*  except the SI3CT parameters which we will do now.  Then the SIPCC *
*  macro will be moved to the ECB and any error conditions set up if *
*  need be.                                                          *
**********************************************************************
         LA    R6,EBX000              set up params for sipc
         SI3CT REG=R6                 get dsect
         XC    SI3CT(SI3USRL),SI3CT   clear IPC control area   @32LCIPC
         MVI   SI3DSTN,SI3DSTN_LIST   indicate destination list@32LCIPC
         SPACE ,
         CLI   FUNCTEST,FTLEVEL       function test mode?
         BNE   NOIPCERR               no - continue with SIPCC @32LCIPC
         CLI   ERRORIND,C'8'          error 8 indicated?       @32LCIPC
         BNE   NOIPCERR               no, destination correct  @32LCIPC
         MVI   SI3DSTN,32             yes, set invalid ordinal @32LCIPC
         SPACE ,
NOIPCERR DS    0H
         MVI   SI3FLGS,X'00'          zero out the flags
         MVI   SI3FLGU,(SI3XMIT+SI3XERR+SI3ALL_IS) set flags   @32LCIPC
         MVI   SI3LEN1,X'18'          dat1 is always 24 bytes long
         MVC   SI3LEN2,CE1CC2         len of data block
         MVC   SIPCMAC,SIPCCODE       move to ECB            TD00264
         CLI   ERRORIND,NOERROR       is there an error to create?
         BE    SIPC                   no - do the sipc
         BAS   R5,CREATERR            yes - create the error
SIPC     DS    0H
         BAS   R5,SIPCMAC             execute SIPCC macro    TD00264
**********************************************************************
* Now we will test SI3FLGS to see if any processors went inactive    *
* during the issuance of the SIPCC.  Then we will wait on the event  *
* for the error/normal return.  A not found condition is ok since it *
* may have been posted to completion or we were HPO, uni, 1 I-Stream *
**********************************************************************
         TM    SI3FLGS,SI3INAC        inactive processors
         BZ    WAITON1                nope
         BAS   R5,INACT               send message
WAITON1  DS    0H
         L     R3,CE1CR1              base of event block 1    @32LCIPC
         EVNWC TYPE=LIST,                                              X
               BLOCK=(R3),                                             X
               NFOUND=NF1                                      @32LCIPC
NF1      DS    0H                    not found is ok...see logic
         CLI   FUNCTEST,FTLEVEL      one shot?
         BNE   CLEAR1                no
         BAS   R5,CLEARED1           yes
CLEAR1   DS    0H
         TM    EVNBKE,X'80'          did we timeout?
         BZ    WAITON2               no...wait on other
         BAS   R5,TIMEOUT1           send a message
         L     R3,CE1CR3             base of event list 2      @32LCIPC
         POSTC TYPE=LIST,            post fully                        X
               BLOCK=(R3),                                             X
               NFOUND=NOTFOUND,                                        X
               LINFND=LINFOUND                                 @32LCIPC
**********************************************************************
* Now we will wait on the SIPCC event.  In both events a timeout is  *
* bad and if the first event times out we post to completion the     *
* second event.                                                      *
**********************************************************************
WAITON2  DS    0H
         L     R3,CE1CR3              base of event block 2    @32LCIPC
         EVNWC TYPE=LIST,                                              X
               BLOCK=(R3),                                             X
               NFOUND=NF2                                      @32LCIPC
NF2      DS    0H                    not found is ok
         CLI   FUNCTEST,FTLEVEL      one shot?
         BNE   CLEAR2                no
         BAS   R5,CLEARED2           yes
CLEAR2   DS    0H
         TM    EVNBKE,X'80'          did we timeout?
         BZ    CONTINU               no...continue
         BAS   R5,TIMEOUT2
**********************************************************************
* We will now set up to continue.  We will first increment the SIPC  *
* counter in the global then check to ensure we are still allowed to *
* be running.  If so we increment the block type counter and release *
* the old block.  If we have not gone through all types of blocks    *
* then we branch to the top of SIPCLOOP, else we set up a CRET.  The *
* time interval for the CRETC defaults to 3, but it can be overidden *
* by a value in the global.                                          *
**********************************************************************
CONTINU  DS    0H
         CLI   FUNCTEST,FTLEVEL      one shot?
         BE    QUIT                  yes - nothing further needed
         L     R7,GLBLSAVE           restore global address
         LH    R5,UD0SIPC+2          get value
         LA    R5,1(R5)              add one
         STH   R5,UD0SIPC+2          save it
         LA    R4,1(R4)              inc block counter
         RELCC D2                    release the block
         RELCC D1                    release list 1
         RELCC D3                    release list 2
         CLI   UD0SIPC,RUNNIN        indicator set?
         BNE   QUIT                  no - quit
         C     R4,THREE              is it three or less
         BNH   SIPCNEXT              yes, do setup             @32LCIPC
         ICM   R15,B'1000',=C'C'     indicate a cret
         ICM   R15,B'0111',EBROUT    pass ebrout also
         LA    R14,3                 default time of 3
         CLI   UD0SIPC+1,STDTIME     is the global cleared?
         BE    DOCRET                yes - CRET
         ICM   R14,B'0001',UD0SIPC+1 else load new time
DOCRET   DS    0H
         CRETC S,QIP0,STATE=1052     cret time changed here
         EXITC
         SPACE 1                                               @32LCIPC
SIPCNEXT DS    0H                                              @32LCIPC
         BAS   R5,CREATE_LIST        go do list setups         @32LCIPC
         B     SIPCLOOP              ..and process next block  @32LCIPC
         EJECT ,
***********************************************************************
* Here are all of the subroutines that are called via a BAS.  They    *
* are maybe grouped in order caller to callee.                        *
***********************************************************************
***********************************************************************
* For any messages ouput due to bad sipc's.                           *
***********************************************************************
CLEARED1 DS    0H
         LA    R7,SMSG17          FCT - event 1 cleared
         B     OUTMSG
CLEARED2 DS    0H
         LA    R7,SMSG19          FCT - event 2 cleared
         B     OUTMSG
TIMEOUT1 DS    0H
         LA    R7,SMSG8           FCT/SVT - timeout
         B     OUTMSG
TIMEOUT2 DS    0H
         LA    R7,SMSG18          FCT/SVT - timeout
         B     OUTMSG
NOTFOUND DS    0H
         LA    R5,WAITON2         FCT/SVT - can't find timed event
         LA    R7,SMSG10
         B     OUTMSG
LINFOUND DS    0H
         LA    R5,WAITON2         FCT/SVT - can't find timed event
         LA    R7,SMSG10
         B     OUTMSG
STARTED  DS    0H
         LA    R7,SMSG21          SVT - started
         B     OUTMSG
INACT    DS    0H
         LA    R7,SMSG7           FCT/SVT - processor went inactive
OUTMSG   DS    0H
         WTOPC TEXTA=(R7),HEADER=NO,ENDOFM=YES
         BR    R5
***********************************************************************
* Here is a routine that makes sure we are indeed running.            *
***********************************************************************
CHECKRUN DS    0H
         CLI   UD0SIPC,STOPRUN    is it off?
         BE    OFF                yes
         CLC   =C'STAR',PARMWORD  no , but was it start?
         BE    RUNNING            yes - error
         BR    R5                 no - return, write stop/stat msg
OFF      DS    0H
         CLC   =C'STAR',PARMWORD  not running and was it start?
         BER   R5                 yes - return ok
         B     NOTRUN             no - error - output msg.
***********************************************************************
* This will fill each block with unique data.                         *
***********************************************************************
FILLBLK  DS    0H
         L     R1,CE1CR2        get addr of block
         LH    R2,CE1CC2        load size
         AR    R2,R1            copy it
         LA    R1,8(R1)         bump past name3 area           TD00323
FILLIT   DS    0H
         ST    R1,0(R1)         save data - why not an address?
         LA    R1,4(R1)         inc to the next fullword
         LR    R7,R2
         SR    R7,R1
         C     R7,FOUR          do we have room?
         BNL   FILLIT           yes
         BR    R5
***********************************************************************
* This procedure sends will determine if the error code was entered.  *
* If so, then a condition will be set and we return.                  *
*                                                                     *
* Register Conventions:                                               *
*   R1 - Pointer to the input parameter list                          *
*   R2 - Branching                                                    *
*   R5 - Branching                                                    *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX058 - Where the error condition number is to be stored         *
*                                                                     *
***********************************************************************
SETUPERR DS    0H
         BAS   R5,SKIPCHAR            strip off the blk size param
         BAS   R5,LOOKAHED            get rid of blanks
         CLI   0(R1),ENDOFMSG         end of params?
         BER   R2                     yes, no error coded, return
         MVC   ERRORIND,0(R1)         else save the char
         CLI   1(R1),ENDOFMSG         is this a return?                 d13507
         BER   R2                     ok, it's a single digit errnum    d13507
         CLI   1(R1),BLANK            Is this a blank?                  d13507
         BNE   BADPARAM               it's NOT a single digit           d13507
         BR    R2
         EJECT ,
***********************************************************************
* This procedure will create the error by altering the sipc macro     *
* in line.  Note that the re-entrant check will fail here, oh well.   *
*                                                                     *
* Register Conventions:                                               *
*   R5 - Branching                                                    *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX058 - Where the error condition number is to be stored         *
*                                                                     *
***********************************************************************
CREATERR DS    0H
         CLI   ERRORIND,C'0'          error 0?                          d13507
         BE    BADPARAM               yes, invalid                      d13507
         CLI   ERRORIND,C'2'          error 2?
         BE    ERROR2                 yes handle it
         BL    ERROR1                 no - must be 1
         CLI   ERRORIND,C'4'          error 4?
         BE    ERROR4                 yes handle it
         BL    ERROR3                 no - must be 3
         CLI   ERRORIND,C'6'          error 6?
         BE    ERROR6                 yes handle it
         BL    ERROR5                 no - must be 5
         CLI   ERRORIND,C'8'          error 8?                 @32LCIPC
         BE    ERROR8                 yes handle it            @32LCIPC
         BL    ERROR7                 no - must be 7           @32LCIPC
         B     BADPARAM               Can't be anything else  TD00410
ERROR1   DS    0H
         MVI   SI3LEN1,ERROR290       much bigger than 104 opr 290
         BR    R5                     return
ERROR2   DS    0H
         MVC   SI3LEN2,=X'7FFF'       must b = blksize    opr 290
         BR    R5                     return
ERROR3   DS    0H
         MVC   SI3LEN2,=X'7FFF'       must b = blksize    opr 290
         BR    R5                     return
ERROR4   DS    0H
         RELCC D2                     rel blk...opr 291
         BR    R5                     return
ERROR5   DS    0H
         MVI   CE1CT2+1,X'66'         invalid block type  opr 291
         BR    R5                     return
ERROR6   DS    0H
         MVI   RETCODE,ERROR292       ret set & no prog coded opr 292
         BR    R5                     return
ERROR7   DS    0H
         L     R14,CE1CR3             Get List base
         MVC   EVNBKLC-EV0BK(2,R14),=X'0200'  LIST size > max opr 296
         BR    R5                     return
ERROR8   DS    0H
**CMNT** MVI   SI3DSTN,32             destination > ord # 31  opr 297
         BR    R5                     return
         EJECT ,
***********************************************************************
*        LOOKAHED IS ABLE TO SCAN AN INPUT PARAMTER LIST UNTIL        *
*        A NON-BLANK IS ENCOUNTERED                                   *
***********************************************************************
LOOKAHED DS    0H                      STRIP OFF LEADING BLANKS
         CLI   0(R1),BLANK             Is next char a blank?
         BNER  R5                      NO, IT IS NOT A BLANK, RETURN
         LA    R1,1(,R1)               YES, ADVANCE INPUT PARA LIST PTR
         B     LOOKAHED                KEEP GOING
         EJECT ,
***********************************************************************
* This scans ahead to the next blank, which lets an abbreviation be   *
* used.  If the end of message character (x4E) is hit first, then     *
* obviously it is an error and a subroutine to tell you and exit is   *
* called.  This uses R5 for its branching.                            *
***********************************************************************
SKIPCHAR DS    0H
         CLI   0(R1),BLANK             Is next char a blank?
         BER   R5                      Yes, go back now
         CLI   0(R1),ENDOFMSG          They hit return?
         BER   R5                      Return then
         LA    R1,1(,R1)               Inc that old pointer!
         B     SKIPCHAR
         EJECT ,
***********************************************************************
* This section contains subroutines that exit via EXITC, and do not   *
* return to any caller.  Basically they are messages.                 *
***********************************************************************
***********************************************************************
* This will resend the original message for every active SSU in the   *
* complex.                                                            *
***********************************************************************
CEBICLP  DS    0H
         CLC   =C'STAT',PARMWORD    was it stat?
         BE    NEWSTAT              yes - new status message
         MS0UT REG=R2
         CINFC R,CMMSSUT
         LR    R2,R14               copy reg over
         L     R3,MU0CNT            get # of SS's
SSULOOP  DS    0H
         TM    MU0ID1,MUSUDM        dormant?
         BO    SSINACT              yes...branch around
         LH    R14,MU0SSU           load r14 with mdbf for ssu
         CEBIC SSU                  become this dude
         MVC   LNIATA2,EBROUT       must pass ebrout for msgs
         MVC   WHATPROC,CE1CPD      pass cpd
         LA    R14,9                num of params
         LA    R15,PARMWORD         starting at ebw000
         PRINT GEN
         CREMC QIP0                 crem to myself
         PRINT NOGEN
SSINACT  DS    0H                   also get here if ss is inactive
         AHI   R2,MU0LEN            bump to next ssu                    64ML3221
         BCT   R3,SSULOOP           loop for all ssusers
         DROP  R2
         EXITC
***********************************************************************
* The following processes "STAT ALL" messages.                        *
*                                                                     *
* This command is restricted to the main I-stream, since it is the    *
* only I-stream which has access to other I-stream's unique globals.  *
***********************************************************************
NEWSTAT  DS    0H
         CLC   CE1ISN,=X'0001'     Running on the main I-stream?
         BNE   NOTMAIN             No - go print an error message
         GLOBZ REGR=R15
         DCTIST REG=R7
         CINFC R,CMMIST,F,REG=R7
         LH    R14,ISTUSEIS        Maximum usable i/s
         DROP  R7
         STH   R14,EBX000          Save max i/s number in ECB.
         GETCC D4,L0               Get a scratch block for header
         L     R1,CE1CR4           Load address of core block
         ST    R1,CE1UR1           Save R1 so it can be used here       d10688
         CINFC R,CMMSSAT,F,REG=R6
         MS0AT REG=R6              Subsystem attribute table
         MS0UT REG=R4              Subsystem user table
         ST    R6,CE1UR6           Save R6 so it can be used here       f4229
         ST    R4,CE1UR4           Save R4 so it can be used here       d10688
         L     R7,MA0CNT           Number of subsystems
         SR    R3,R3               Clear R3                             f4229
**********************************
* Print the title of the table   *
**********************************
         WTOPC PREFIX=SIPC,NUM=23,LET=I,TEXT='SIPC STATUS TABLE',      Xd10573
               ENDOFM=NO,CHAIN=YES,PAGE=YES,PAGESTOP=SUBMSG             d10573
*
         LA    R15,HDRTXT          Load address of target msg txt       d10688
         STH   R7,EBX004           Save total number of SS for MOVEMSG  d10688
         BAS   R5,MOVEMSG          move 'SS' in place                   d10688
         LA    R1,10(R1)           point to the place for 1st SS name   d10688
***********************************************************************
*  NEXT is a BAL loop based on R7.  It loops through MS0AT            *
*  to compute the total number of SSU           *
*  R4 now holds base of SSU table for this SS after the UATBC         *
***********************************************************************
NEXT     DS    0H
         L     R4,MA0NAM           Name of the subsystem
         MVC   0(4,R1),MA0NAM      Set the SS name for CHAINMSG         d10688
         SR    R2,R2               Clear R2                             d10688
         IC    R2,MA0NUM           Load the number of SSUs in this SS   d10688
         MHI   R2,L'ISSTAT         compute the length jump for next     d10688
         AR    R1,R2               Increment the pointer to the place   d10688
         UATBC IDLOC=(N,SSI,R4),                                       X
               NOTAVL=SSINACT2,                                        X
               COUNT=R5            Returns number of ssu's              f4229
         AR    R3,R5               Accumulate to R3                     f4229
         LA    R6,SSATSZ(,R6)      Bump to next SS entry                f4229
         BCT   R7,NEXT                                                  f4229
         STH   R3,EBX004           Save total number of SSU in ECB      f4229
         L     R6,CE1UR6           Restore R6 from save area            f4229
**********************************
* Print the SSs header           *
**********************************
         L     R1,CE1UR1           Restore R1 for print         d10688  f4229
         BAS   R5,CHAINMSG         Print the header for SSs     d10688  f4229
*
         LA    R15,HDR1TXT         Load address of target msg txt
         BAS   R5,MOVEMSG          move 'SSU' into place                d10688
         LA    R1,10(R1)           point to the place for 1st SSU name  d10688
*
         L     R4,MA0NAM           Load the name of base subsystem      d10688
         UATBC IDLOC=(N,SSI,R4),                                       Xd10688
               NOTAVL=SSINACT2                                          d10688
NEXT1    DS    0H                                                       d10688
         MVC   0(4,R1),MU0NAM      Set the SS name for CHAINMSG         d10688
         LA    R1,L'ISSTAT(R1)     Point to next position               d10688
         AHI   R4,MU0LEN           Bump to next SSU entry               d10688
         BCT   R3,NEXT1            Go once for each SSU                 d10688
         L     R4,CE1UR4           Restore R6 from save area    d10688  f4229
*********************************
* Print the SSUs header          *
**********************************
         L     R1,CE1UR1           Restore R1 for print         d10688  f4229
         BAS   R5,CHAINMSG         print SSU header                     d10688
*                                                                       d10688
         L     R4,MA0NAM           Name of the subsystem
         UATBC IDLOC=(N,SSI,R4),                                       Xf4229
               NOTAVL=SSINACT2                                          f4229
         SR    R6,R6               Set zero to R6                       f4229
         SR    R14,R14             R14 = index into SSU tb              f4229
         STC   R14,EBX008          Put zero to IS number count          f4229
         LH    R0,EBX000           Get max i/s number                   f4229
***********************************************************************
*  ISLOOP is a BAL loop based on R0.  It loops through each           *
*  of the SSU for the machine.  The status of SIPC is                 *
*  displayed for each of SSU.  Because of imbedding,                  *
*  this loop gets executed for each I-stream of each                  *
*  subsystem defined in the system.                                   *
*                                                                     *
*  The CTIN global relocation table will be used to locate            *
*  application I-stream's unique globals in high memory on the main   *
*  I-stream.                                                          *
***********************************************************************
ISLOOP   DS    0H                                                       f4229
         USING STATLINE,R1
         L     R1,CE1CR4             Msg built in D4 block
         LA    R15,#ISNAME           Load address of target message     f4229
         BAS   R5,MOVEMSG
*******************************
* Put in IS number into place *
*******************************
         SR    R5,R5                 Set zero to R5                     f4229
         IC    R5,EBX008             Get IS number                      f4229
         LA    R5,1(R5)              Add one                            f4229
         STC   R5,EBX008             Update the old count               f4229
         LA    R15,ISNUM             WHERE TO PLACE                     f4229
         #COND INPUT=R5,TO=R15,LENGTH=2 BINARY TO EBCDIC                f4229
         LH    R3,EBX004             Get total number of SSU in ECB     f4229
***********************************************************************
*  SSULOOP1 is a BAL loop based on R3.  It loops through the          *
*  subsystem users of all subsystem.                                  *
*  Upon entry, R4 holds the base of the SSU table                     *
*              R3 holds the TOTAL number of subsystem users in all SS *
*              R11 holds the offset of MU0GLA to the target IS        *
***********************************************************************
SSULOOP1 DS    0H                    Process individual ssu's           f4229
         L     R15,MU0GLA(R14)       Base of this SSU's GLBL1  on main
         LA    R15,@ISUDRV           Base of this SSU's @ISUDRV on main
         CINFC R,CMMGLBTB,F,REG=R13  Get Relocation Table address
         S     R15,0(,R13)           Calculate displacement of @ISUDRV
         LH    R7,EBX000             Create index into relocation table
         SR    R7,R0                 R7 = I-stream number minus 1
         SLL   R7,2                  Multiply IS number to create index
         A     R15,0(R7,R13)         Locate @ISUDRV for this I-stream
         L     R15,0(R15)            Retrieve I-S unique record
         S     R15,0(R13)            Calculate high-storage address
         A     R15,0(R7,R13)         Rebase address
*
         DROP  R15
         UD0RV REG=R15
         CLI   UD0SIPC,STOPRUN       Is SIPC active?
         BE    SSUCONT               No - go process next I-stream
         SR    R2,R2
         LH    R2,UD0SIPC+2          load global
         CVD   R2,EBW000             convert to garbage
         UNPK  EBX096(5),EBW005(3)   unpack it
         MVZ   EBX100,EBX096         move zone
         MVC   ISSTAT(5),EBX096      move the number in
         MVI   ISSTAT+5,BLANK        overwrite the v from inactv
SSUCONT   DS    0H                                                      f4229
         LA    R1,L'ISSTAT(R1)     Tab to next IS field in line
         AHI   R14,MU0LEN          Bump to next SSU entry               f4229
         BCT   R3,SSULOOP1         Go once for each SSU                 f4229
STATMSG2 DS    0H
         DROP  R15
         L     R1,CE1CR4           Restore addressability to msg blok
         ST    R0,CE1UR0           Save R0 so before WTOPC              f4229
         BAS   R5,CHAINMSG                                              f4229
         L     R0,CE1UR0           Restore R0 after WTOPC               f4229
         LA    R6,MU0GSZ(R6)       Set up the offset of next IS         f4229
         LR    R14,R6              Reset the starting value of R14      f4229
         BCT   R0,ISLOOP                                                f4229
SSINACT2 DS    0H
         RELCC D4
         LA    R1,ENDMSG
         B     SUBMSG
         EJECT ,
***********************************************************************
* MOVEMSG is a generic procedure to calculate the length of both TOPCs*
* and move them onto data level 4, storing the length in the first    *
* byte.  Register usage is described below:                           *
*                                                                     *
* R1  - Address of block                                              *
* R2  - Number of bytes to move                                       *
* R5  - Branching                                                     *
* R15 - Address of message text to be moved                           *
*                                                                     *
***********************************************************************
MOVEMSG  DS    0H
         LH    R2,EBX004           Get total number of SSU
         MH    R2,=Y(L'STATIND)    Multiply SSU count by label length
         LA    R2,EXTRA(R2)        Calc actual WTOPC length
         STC   R2,0(R1)            Store length in first byte
         BCTR  R2,R0               Subtract 1 for MVC
         EX    R2,MOVECODE         Move in status info template
         BR    R5                  return
MOVECODE DS    0H
         MVC   1(0,R1),0(R15)      Move in text/skip len byte
         EJECT ,
***********************************************************************
* CHAINMSG is a generic call to write a WTOPC chained message line    *
* where R1 holds the test to be used.                                 *
*                                                                     *
* R1  - Address of block                                              *
* R5  - Branching                                                     *
*                                                                     *
***********************************************************************
CHAINMSG DS    0H
         WTOPC TEXTA=(R1),HEADER=NO,ENDOFM=NO,CHAIN=YES,PAGE=YES,      Xf4229
               PAGESTOP=SUBMSG,NEXTPAGE=NEXT_PG                         d10573
         BR    R5                  return                      @32LCIPC
         EJECT ,

NEXT_PG  WTOPC PREFIX=SIPC,NUM=23,LET=I,TEXT='SIPC STATUS TABLE',      Xd10573
               ENDOFM=NO,CHAIN=YES,PAGE=YES,PAGESTOP=SUBMSG             d10573
         BR    R5                                                       d10573
         EJECT ,                                                        d10573

***********************************************************************
* CREATE_LIST will create 2 processor LISTs used for SIPCC and EVNTC. *
* These LISTs will include all active processors (including us) and   *
* are used to specify the IPC destination processors as well as to    *
* define th LIST of processors to await rrsponses from for Events 1&2.*
***********************************************************************
         SPACE 1
CREATE_LIST DS 0H                                              @32LCIPC
         GETCC D1,L2,FILL=00          allocate list block      @32LCIPC
         L     R3,CE1CR1              address block            @32LCIPC
         GENLC TYPE=CREATE,           create a proc list               X
               BLOCK=(R3),                                             X
               DATA=PROCESSOR,                                         X
               INCLUDE=ACTIVE         Active procs (not me)    @32LCIPC
         SPACE ,
         CINFC R,CMMIST,F,REG=R1      get IST                 TD00323
         DCTIST REG=R1                IST Dsect               TD00323
         XR    R2,R2                  zero scratch reg         @32LCIPC
         LH    R2,ISTUSEIS            get useable is's         @32LCIPC
         CH    R2,ONE+2               only 1 IS?               @32LCIPC
         BNH   COPYLIST               yes, 1 IS, continue      @32LCIPC
         CINFC R,CMMPID               get pidt in r14
         LA    R6,PI1CIDN+1           point to our ord#        @32LCIPC
         LA    R2,1                   count for genlc          @32LCIPC
         GENLC TYPE=MODIFY,           add our proc to list             X
               BLOCK=(R3),                                             x
               DATA=(R6),                                              x
               COUNT=(R2),                                             X
               INCLUDE=ALL
         SPACE ,
COPYLIST DS    0H
         GETCC D3,L2,FILL=00          allocate list block      @32LCIPC
         SPACE ,
         L     R2,CE1CR1              base of from block       @32LCIPC
         LH    R3,CE1CC1              len  of from block       @32LCIPC
         L     R14,CE1CR3             base of to block         @32LCIPC
         LR    R15,R3                 len  of to block         @32LCIPC
         MVCL  R14,R2                 copy block data          @32LCIPC
         SPACE ,
         BR   R5                      return                   @32LCIPC
         DROP  R1                                             TD00323
         EJECT ,
***********************************************************************
* Sets up for a wtopc if bad parameters are used.                     *
***********************************************************************
BADPARAM DS    0H
         LA    R1,SMSG2            msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if not running currently                        *
***********************************************************************
NOTRUN   DS    0H
         CLC   =C'STAT',PARMWORD   is it a stat command?
         BE    STATSTOP            yes, print out an informational msg
         LA    R1,SMSG3            no, print an err msg
         B     SUBMSG
STATSTOP LA    R1,SMSG12
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if running currently                            *
***********************************************************************
RUNNING  DS    0H
         LA    R1,SMSG20           msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if invalid cret time entered                    *
***********************************************************************
INVNUM   DS    0H
         LA    R1,SMSG24           msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC for new cret time entered                      *
***********************************************************************
NEWCRET  DS    0H
         LA    R1,SMSG25           msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC for "STAT ALL" not on main I-stream             *
***********************************************************************
NOTMAIN  DS    0H
         LA    R1,SMSG31           msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if not loosely coupled                          *
***********************************************************************
NOTLC    DS    0H
         LA    R1,SMSG1            msg addr
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc to notify of stoppage                           *
***********************************************************************
STOPMSG  DS    0H
         LA    R7,SMSG4            msg addr
         BAS   R5,OUTMSG           write msg & fall thru to status
         L     R7,EBX096           restore saved global addr
***********************************************************************
* Sets up for a WTOPC to write the status                             *
***********************************************************************
STATMSG  DS    0H
         LA    R1,SMSG5              msg addr
         UD0RV REG=R7
         LH    R4,UD0SIPC+2          load global
         CVD   R4,EBW000             convert to garbage
         UNPK  EBX096(5),EBW005(3)   unpack it
         MVZ   EBX100,EBX096         move zone
         LA    R3,EBX096             get addr
         B     SUBMSG
NEEDHELP DS    0H
         LA    R1,SMSG6              msg addr
         B     SUBMSG
QUIT     DS    0H
         LA    R1,SMSG9              msg addr
***********************************************************************
* For any I,E,W messages that might require substitutions...ingenious!*
***********************************************************************
SUBMSG   DS    0H
         WTOPC TEXTA=(R1),SUB=(CHARA,(3)),CHAIN=YES,                   X
               HEADER=NO,ENDOFM=YES
         EXITC
         EJECT ,
***********************************************************************
* All Data is stored here as well as the output messages given all    *
* through this sleigh ride.                                           *
***********************************************************************
ZEROS    DC    F'0'
ONE      DC    F'1'
TWO      DC    F'2'
THREE    DC    F'3'
FOUR     DC    F'4'
         SPACE ,
SIPCCODE DS    0H
         L     R3,CE1CR3
         PRINT GEN                                             @32LCIPC
         SIPCC PGM=QIP1,                                               X
               CREG=R6,                                                X
               DLBL=EBX032,                                            X
               LEV=D2,                                                 X
               RETURN=QIP2,                                            X
               TYPE=IS,                                                X
               LIST=EVNBKLW                                    @32LCIPC
         PRINT NOGEN                                           @32LCIPC
         BR    R5                                           TD00264
SIPCLEN  EQU   *-SIPCCODE
***********************************************************************
* All equates needed are stored here.                                 *
***********************************************************************
PARMWORD EQU   EBW000,4                                       TD00326
CRETPARM EQU   EBW000,1                                       TD00326
LNIATA1  EQU   EBW001,3                                       TD00326
LNIATA2  EQU   EBW004,3                                       TD00326
WHATPROC EQU   EBW007,1                                       TD00326
FUNCTEST EQU   EBX032,4
NAME1    EQU   EBX036,8       These are the equates I need for all of
NAME2    EQU   EBX044,8       my flags and parameter.  SI3CT and EV0BK
ROUTE    EQU   EBX052,4       will also be used in their original
*        EQU   EBX056,2       unused                           @32LCIPC
DUMMY    EQU   EBX056
*        EQU   EBX057         unused                           @32LCIPC
ERRORIND EQU   EBX058
TRANLIST EQU   EBX059
*        EQU   EBX060         unused                           @32LCIPC
GLBLSAVE EQU   EBX096,4
SIPCMAC  EQU   EBW040,SIPCLEN                                  @32LCIPC
RETPROG  EQU   SIPCMAC+18,8                                   TD00264
RETCODE  EQU   SIPCMAC+25                                      @32LCIPC
RUNNIN   EQU   X'FF'                                          TD00326
STOPRUN  EQU   X'00'                                          TD00326
STDTIME  EQU   X'00'                                          TD00326
FTLEVEL  EQU   X'FF'                                          TD00326
STLEVEL  EQU   X'00'                                          TD00326
ERROR290 EQU   X'FF'                                          TD00326
ERROR292 EQU   X'00'                                          TD00326
NOERROR  EQU   X'00'                                          TD00326
BLANK    EQU   X'40'                                          TD00326
ENDOFMSG EQU   X'4E'                                          TD00326
CRET     EQU   C'C'                                           TD00326
***********************************************************************
*  Here are messages issued by WTOPC's.                               *
***********************************************************************
** Formatting for the header line
HDR      DC    AL1(0)                                                   f4229
HDRTXT   DC    CL8' SS'                                                 f4229
SSLBLS   DS    6CL7' '                                        d10688    f4229
*
HDR1     DC    AL1(0)
HDR1TXT  DC    CL8' SSU'                                                f4229
EXTRA    EQU   (*-HDR1TXT)
SSULBLS  DS    6CL7' '                                        d10688    f4229
* Formatting for each status line
STAT     DC    AL1(0)
#ISNAME  DC    CL8'IS-'                                                 f4229
STATIND  DC    CL7'INACT'         I/S 1 status                          f4229
         DC    CL7'INACT'                                               f4229
         DC    CL7'INACT'                                               f4229
         DC    CL7'INACT'                                               f4229
         DC    CL7'INACT'                                     d10688    f4229
         DC    CL7'INACT'                                     d10688    f4229
ACTIVE   DC    CL7'ACTIV'
ENDMSG   EQU   *
LENMSG   DC    AL1(ENDMSG2-ENDMSG1)
ENDMSG1  DC    C'END OF DISPLAY'
ENDMSG2  EQU   *
NAMEMSG  EQU   *
LENNAME  DC    AL1(NAMEMSG2-NAMEMSG1)
NAMEMSG1 DC    C'....'
NAMEMSG2 EQU   *
SMSG1    EQU   *
         DC    AL1(SMSG1E-SMSG1S)                              TD00323
SMSG1S   DC    C'SIPC0001E YOU MUST HAVE HPO INSTALLED TO EXECUTE'
SMSG1E   EQU   *
SMSG2    EQU   *
         DC    AL1(SMSG2E-SMSG2S)
SMSG2S   DC    C'SIPC0002E INVALID PARAMETERS.  TYPE SIPC ? FOR HELP'
SMSG2E   EQU   *
SMSG3    EQU   *
         DC    AL1(SMSG3E-SMSG3S)
SMSG3S   DC    C'SIPC0003E DRIVER IS NOT CURRENTLY RUNNING'
SMSG3E   EQU   *
SMSG4    EQU   *
         DC    AL1(SMSG4E-SMSG4S)
SMSG4S   DC    C'SIPC0004I DRIVER IS NOW STOPPING'
SMSG4E   EQU   *
SMSG5    EQU   *
         DC    AL1(SMSG5E-SMSG5S)
SMSG5S   DC    C'SIPC0005I SIPC COUNTS ARE: .....'
SMSG5E   EQU   *
SMSG6    EQU   *
         DC    AL1(SMSG6E-SMSG6S)
SMSG6S   DC    C'SIPC0006I SIPC PARAMETERS ARE:',AL1(#CAR)
         DC    C'  STARt | STOP | STATus  <ALL>',AL1(#CAR)
         DC    C'  SPEEd time <ALL> where time is 1-9',AL1(#CAR)
         DC    C'  SMall | LArge | 4K <errnum> where errnum:',AL1(#CAR)
         DC    C'  1,2,3   CTL-I000290',AL1(#CAR)
         DC    C'  4,5     CTL-I000291',AL1(#CAR)
         DC    C'  6       CTL-I000292',AL1(#CAR)
         DC    C'  7       CTL-I000296',AL1(#CAR)
         DC    C'  8       CTL-I000297'
SMSG6E   EQU   *
SMSG7    EQU   *
         DC    AL1(SMSG7E-SMSG7S)
SMSG7S   DC    C'SIPC0007E AT LEAST ONE PROCESSOR INACTIVE. POSTING '
         DC    C'WITH PROPER MASK'
SMSG7E   EQU   *
SMSG8    EQU   *
         DC    AL1(SMSG8E-SMSG8S)
SMSG8S   DC    C'SIPC0008E EVENT 1 HAS TIMED OUT'
SMSG8E   EQU   *
SMSG9    EQU   *
         DC    AL1(SMSG9E-SMSG9S)
SMSG9S   DC    C'SIPC0009I SIPC DRIVER IS NOW ENDED'
SMSG9E   EQU   *
SMSG10   EQU   *
         DC    AL1(SMSG10E-SMSG10S)
SMSG10S  DC    C'SIPC0010E EVENT 2 NOT FOUND'
SMSG10E  EQU   *
SMSG11   EQU   *
         DC    AL1(SMSG11E-SMSG11S)
SMSG11S  DC    C'SIPC0011E EVENT 2 LIST ITEM NOT FOUND'
SMSG11E  EQU   *
SMSG12   EQU   *
         DC    AL1(SMSG12E-SMSG12S)
SMSG12S  DC    C'SIPC0012I DRIVER IS NOT CURRENTLY RUNNING'
SMSG12E  EQU   *
SMSG17   EQU   *
         DC    AL1(SMSG17E-SMSG17S)
SMSG17S  DC    C'SIPC0017I EVENT 1 HAS BEEN CLEARED'
SMSG17E  EQU   *
SMSG18   EQU   *
         DC    AL1(SMSG18E-SMSG18S)
SMSG18S  DC    C'SIPC0018I EVENT 2 HAS TIMED OUT'
SMSG18E  EQU   *
SMSG19   EQU   *
         DC    AL1(SMSG19E-SMSG19S)
SMSG19S  DC    C'SIPC0019I EVENT 2 HAS BEEN CLEARED'
SMSG19E  EQU   *
SMSG20   EQU   *
         DC    AL1(SMSG20E-SMSG20S)
SMSG20S  DC    C'SIPC0020E DRIVER IS CURRENTLY RUNNING'
SMSG20E  EQU   *
SMSG21   EQU   *
         DC    AL1(SMSG21E-SMSG21S)
SMSG21S  DC    C'SIPC0021I DRIVER NOW STARTING'
SMSG21E  EQU   *
SMSG24   EQU   *
         DC    AL1(SMSG24E-SMSG24S)
SMSG24S  DC    C'SIPC0024E INVALID CRET TIME SPECIFIED, USE 1-9'
SMSG24E  EQU   *
SMSG25   EQU   *
         DC    AL1(SMSG25E-SMSG25S)
SMSG25S  DC    C'SIPC0025I CRET TIME CHANGED AND LOADED IN GLOBAL'
SMSG25E  EQU   *
SMSG31   EQU   *
         DC    AL1(SMSG31E-SMSG31S)
SMSG31S  DC    C'SIPC0031E "STAT ALL" VALID ONLY ON MAIN I-STREAM'
SMSG31E  EQU   *
         LTORG
         FINIS QIP0
         END
