         PRINT NOGEN
         BEGIN NAME=QIP1,IBM=YES                  CREATED    08/26/86
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*   MODULE NAME = SEE BELOW                                           *
*                                                                     *
*        SOURCE MODULE NAME =  QIP1, ORGINAL VERSION OF SIPC          *
*                                                                     *
*        OBJECT MODULE NAME =  QIP1                                   *
*                                                                     *
*        RELATED MODULE NAME =                                        *
*                                                                     *
*   DESCRIPTIVE NAME = SYSTEM DRVIER FOR TPF 3.2 VIRTUAL              *
*                                                                     *
*   STATUS = VERSION 1  MODIFICATION 2  (REMOTE RETURN PROGRAM)       *
*                                                                     *
* FUNCTION=                                                           *
*                                                                     *
*  SIPC IS ABLE TO PROVIDE THE FOLLOWING FUNCTIONS:                   *
*                                                                     *
*  1. TO TEST THE IPC PATH BETWEEN ANY TWO PROCESSORS IN A LOOSELY-   *
*     COUPLED ENVIRONMENT.                                            *
*                                                                     *
*  2. TO VERIFY THE SEQUENCE OF BLOCKS SENT VIA A SIPC ARRIVE IN      *
*     CORRECT SEQUENCE.                                               *
*                                                                     *
***********************************************************************
***********************************************************************
* This procedure receives the SIPC, verifies the passed data and will *
* re-send it back to the original processor.                          *
*                                                                     *
* Register Conventions:                                               *
*   R1 - Passed block address                                         *
*   R2 - Count of bytes in a block                                    *
*   R3 - Base for the SI3CT Dsect                                     *
*   R5 - Branching                                                    *
*   R6 - Branching                                                    *
*   R7 - Scratch                                                      *
*   R14 - Scratch                                                     *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of SI3CT dsect                                     *
*   EBX040 - Start of EV0BK dsect                                     *
*   EBW000 - Start of PARMS dsect                                     *
*                                                                     *
***********************************************************************
         EJECT ,
         CZ1CP                                                 DRV
         MVC   EBROUT,ROUTE           get ebrout to parms
         MVC   EBX100,CE1CPD          save our id
         MVC   CE1CPD,ROUTE+3         get cpu id
         BAS   R4,CHKBLKS            check the data
         CLI   FUNCTEST,X'FF'        one shot?
         BNE   GETPARMS              no - ferget it
         BAS   R5,GOTIT
GETPARMS DS    0H
         XC    EBX040(16),EBX040      clear ecb workarea      TD00323
         LA    R2,EBX040              base for EV0BK dsect    TD00323
         EV0BK                        declare dsect           TD00323
         USING EV0BK,R2               set up addressability   TD00323
         L     R1,CE1CR0              get base of passed blk  TD00323
         MVC   EVNBKN,0(R1)           move name3              TD00323
         CINFC R,CMMIST,F,REG=R14     get IST                 TD00323
         DCTIST REG=R14               IST Dsect               TD00323
         XR    R5,R5                  zero scratch reg        TD00323
         LH    R5,ISTUSEIS            get useable is's        TD00323
         BCTR  R5,R0                  minus ours              TD00323
         CLC   EBX100,CE1CPD          is this the orig proc?  TD00323
         BNE   NOTORIG                no                      TD00323
         BCTR  R5,R0                  minus one more          TD00323
NOTORIG  DS    0H                                             TD00323
         CH    R5,ZERO                is r5<=0?               TD00323
         BNH   CLEARED                yes-blow off event3     TD00323
         STH   R5,EVNBKC1             store for a count       TD00323
         EVNTC BLOCK=EBX040,TYPE=CNT,NAME=Y,DUPNAM=BEATEN,             X
               STATE=1052                                     TD00323
         EVNWC BLOCK=EBX040,TYPE=CNT,ERROR=TIMEOUT,NFOUND=NOTFND
         B     CLEARED                other is's posted me    TD00323
BEATEN   DS    0H                     event setup already     TD00323
         POSTC BLOCK=EBX040,TYPE=CNT,NFOUND=NOTFND            TD00323
         EXITC                        post ecb lives to exit  TD00323
CLEARED  DS    0H                                             TD00323
         CLI   FUNCTEST,X'FF'         function test mode?     TD00323
         BNE   SENDRPLY               no                      TD00323
         BAS   R5,E3CLEAR             write message           TD00323
SENDRPLY DS    0H                                             TD00323
         LA    R3,EBX000              set up params for sipc
         SI3CT REG=R3                 get dsect
         CLC   EBX100,CE1CPD          is this the orig proc?  TD00323
         BNE   SENDSIPC               no                      TD00323
         GETCC D3,L2,FILL=00          allocate POST LIST block @32LCIPC
         L     R2,CE1CR3              x
         LA    R5,1                   count/size for GENLC     @32LCIPC
         GENLC TYPE=CREATE,           create POST LIST                 X
               BLOCK=(R2),                                             X
               DATA=SI3ORIG,                                           X
               COUNT=(R5),                                             X
               SIZE=(R5)                                       @32LCIPC
         SPACE ,
         MVC   EVNBKN,NAME2           move in name 2          TD00323
         SPACE ,
         POSTC TYPE=LIST,             post event 2                     X
               BLOCK=(R2),                                             X
               NFOUND=E2NOTFND,                                        X
               LINFND=E2LINFND                                 @32LCIPC
         SPACE ,
         GENLC TYPE=CREATE,           create POST LIST                 X
               BLOCK=(R2),                                             X
               DATA=SI3ORIG,                                           X
               COUNT=(R5),                                             X
               SIZE=(R5)                                       @32LCIPC
         SPACE ,
         MVC   EVNBKN,NAME1           move in name 1           @32LCIPC
         SPACE ,
         POSTC TYPE=LIST,                                              X
               BLOCK=(R2),            post event 1                     X
               NFOUND=E1NOTFND,                                        X
               LINFND=E1LINFND                                 @32LCIPC
         SPACE ,                                              @32LCIPC
         CLI   FUNCTEST,X'FF'         ft mode?                TD00323
         BNE   QUIT                   nope - exit             TD00323
         BAS   R5,E2POST              issue post message      TD00323
         B     QUIT                                           TD00323
SENDSIPC DS    0H                                             TD00323
         MVC   SI3DSTN,SI3ORIG        move in dest bit
         MVI   SI3FLGS,X'00'          zero out the flags
         MVI   SI3FLGU,X'00'          zero out the flags
         MVI   SI3LEN1,X'18'          dat1 is always 24 bytes long
         MVC   SI3LEN2,CE1CC0         len of data block
         MVC   EBW023,EBX100          send out cpd to qip2
         SIPCC PGM=QIP2,CLBL=EBX000,DLBL=EBW000,LEV=D0,TYPE=IP
QUIT     EXITC
         EJECT ,
***********************************************************************
* Here are all of the subroutines that are called via a BAS.  They    *
* are maybe grouped in order caller to callee.                        *
***********************************************************************
***********************************************************************
* This will check each blocks' data.                                  *
***********************************************************************
CHKBLKS  DS    0H
         L     R1,CE1CR0        get addr of passed block
         LH    R2,CE1CC0        add count
         AR    R2,R1
         LA    R1,8(R1)         skip past name3              TD00323
         BAS   R6,FILLIT
         CLI   FUNCTEST,X'FF'   Ft level?
         BNER  R4               no - return
         BAS   R5,EQUAL         yes - write message
         BR    R4               return
***********************************************************************
* This does the actual checking.                                      *
***********************************************************************
FILLIT   DS    0H
         L     R14,4(R1)        get the number in the nth+1 byte
         S     R14,0(R1)        subtract number in nth byte
         C     R14,FOUR         is it four?
         BE    OKSOFAR          yes equal
         BAS   R5,NOTEQUAL      not equal
         BR    R4               return to main routine
OKSOFAR  DS    0H
         LA    R1,4(R1)         inc to the next fullword
         LR    R7,R2            copy the end point
         SR    R7,R1            sub the end-next fullword
         C     R7,EIGHT         do we have room?
         BL    DONE             no
         B     FILLIT           yes
DONE     DS    0H               quit
         BR    R6
***********************************************************************
* This section contains subroutines that exit via EXITC, and do not   *
* return to any caller.  Basically they are messages.                 *
***********************************************************************
***********************************************************************
* Sets up for a wtopc if bad parameters are used.                     *
***********************************************************************
EQUAL    DS    0H
         LA    R1,SMSG2
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if not running currently                        *
***********************************************************************
NOTEQUAL DS    0H
         LA    R1,SMSG3
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC when event 3 cleared                            *
***********************************************************************
E3CLEAR  DS    0H                                             TD00323
         LA    R1,SMSG7                                       TD00323
         B     SUBMSG                                         TD00323
***********************************************************************
* Sets up for a wtopc to notify of posting of event2                  *
***********************************************************************
E2POST   DS    0H                                             TD00323
         LA    R1,SMSG8                                       TD00323
         B     SUBMSG                                         TD00323
***********************************************************************
* Sets up for a wtopc to notify of stoppage                           *
***********************************************************************
GOTIT    DS    0H
         LA    R1,SMSG4
***********************************************************************
* For any I,E,W messages that might require substitutions...ingenious!*
***********************************************************************
SUBMSG   DS    0H
         WTOPC TEXTA=(R1),SUB=(CHARA,(EBX100,1),CHARA,(CE1CPD,1)),     X
               ENDOFM=YES,HEADER=NO,MF=(E,EBW032)
         BR    R5
         EJECT ,
***********************************************************************
* NFOUND condition hit - very bad                                     *
***********************************************************************
NOTFND   DS    0H                                              TD00323
         LA    R0,SMSG5                                        TD00323
         SERRC E,ED0001,MSG,CP,ECB     dump                    TD00323
***********************************************************************
* Timeout on event 3 - not so bad                                     *
***********************************************************************
TIMEOUT  DS    0H                                              TD00323
         LA    R0,SMSG6                                        TD00323
         SERRC E,ED0002,MSG,CP,ECB     dump                    TD00323
***********************************************************************
* Sets up for a SERRC when event 2 not found                          *
***********************************************************************
E1NOTFND DS    0H                                              TD00323
         LA    R0,SMSG9                                        TD00323
         SERRC E,ED0003,MSG,CP,ECB     dump                    TD00323
***********************************************************************
* Sets up for a SERRC when event 2 LIST item not found                *
***********************************************************************
E1LINFND DS    0H                                              @32LCIPC
         LA    R0,SMSG10                                       @32LCIPC
         SERRC E,ED0004,MSG,CP,ECB     dump                    @32LCIPC
***********************************************************************
* Sets up for a SERRC when event 2 not found                          *
***********************************************************************
E2NOTFND DS    0H                                              TD00323
         LA    R0,SMSG11                                       TD00323
         SERRC E,ED0003,MSG,CP,ECB     dump                    TD00323
***********************************************************************
* Sets up for a SERRC when event 2 LIST item not found                *
***********************************************************************
E2LINFND DS    0H                                              @32LCIPC
         LA    R0,SMSG12                                       @32LCIPC
         SERRC E,ED0004,MSG,CP,ECB     dump                    @32LCIPC
***********************************************************************
* All Data is stored here as well as the output messages given all    *
* through this sleigh ride.                                           *
***********************************************************************
FOUR     DC    F'4'
EIGHT    DC    F'8'
ZERO     DC    H'0'                                            TD00323
***********************************************************************
* All equates needed are here.                                        *
***********************************************************************
FUNCTEST EQU   EBW000,4
NAME1    EQU   EBW004,8
NAME2    EQU   EBW012,8
ROUTE    EQU   EBW020,4
***********************************************************************
*  Here are messages issued by WTOPC's.                               *
***********************************************************************
SMSG2    EQU   *
         DC    AL1(SMSG2E-SMSG2S)
SMSG2S   DC    C'SIPC0012I DATA PASSED TO .. FROM .. IS CORRECT'
SMSG2E   EQU   *
SMSG3    EQU   *
         DC    AL1(SMSG3E-SMSG3S)
SMSG3S   DC    C'SIPC0013E DATA PASSED TO .. FROM .. IS INCORRECT.'
SMSG3E   EQU   *
SMSG4    EQU   *
         DC    AL1(SMSG4E-SMSG4S)
SMSG4S   DC    C'SIPC0014I SIPC RECEIVED AT .. FROM ..'
SMSG4E   EQU   *
SMSG5    EQU   *                                               TD00323
         DC    AL1(SMSG5E-SMSG5S)                              TD00323
SMSG5S   DC    C'SIPC0026E NFOUND BRANCH TAKEN ON EVNxC/POSTC'
SMSG5E   EQU   *                                               TD00323
SMSG6    EQU   *                                               TD00323
         DC    AL1(SMSG6E-SMSG6S)                              TD00323
SMSG6S   DC    C'SIPC0027E TIMEOUT BRANCH TAKEN ON EVENT 3'
SMSG6E   EQU   *                                               TD00323
SMSG7    EQU   *                                               TD00323
         DC    AL1(SMSG7E-SMSG7S)                              TD00323
SMSG7S   DC    C'SIPC0028I EVENT 3 CLEARED ON .. FROM ..'
SMSG7E   EQU   *                                               TD00323
SMSG8    EQU   *                                               TD00323
         DC    AL1(SMSG8E-SMSG8S)                              TD00323
SMSG8S   DC    C'SIPC0029I POSTING INTER I-STREAM EVENT 2 ON '
         DC    C'PROCESSOR ..'                                 TD00323
SMSG8E   EQU   *                                               TD00323
SMSG9    EQU   *                                               TD00323
         DC    AL1(SMSG9E-SMSG9S)                              TD00323
SMSG9S   DC    C'SIPC0030E INTER I-STREAM EVENT 1 NOT FOUND'
SMSG9E   EQU   *                                               TD00323
SMSG10   EQU   *                                               @32LCIPC
         DC    AL1(SMSG10E-SMSG10S)                            @32LCIPC
SMSG10S  DC    C'SIPC0031E INTER I-STREAM EVENT 1 LIST ITEM NOT FOUND'
SMSG10E  EQU   *                                               @32LCIPC
SMSG11   EQU   *                                               @32LCIPC
         DC    AL1(SMSG11E-SMSG11S)                            @32LCIPC
SMSG11S  DC    C'SIPC0032E INTER I-STREAM EVENT 2 NOT FOUND'   @32LCIPC
SMSG11E  EQU   *                                               @32LCIPC
SMSG12   EQU   *                                               @32LCIPC
         DC    AL1(SMSG12E-SMSG12S)                            @32LCIPC
SMSG12S  DC    C'SIPC0033E INTER I-STREAM EVENT 2 LIST ITEM NOT FOUND'
SMSG12E  EQU   *                                               @32LCIPC
         LTORG
         FINIS QIP1
         END
