         PRINT NOGEN
         BEGIN NAME=QIP2,IBM=YES                  CREATED    08/26/86
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*   MODULE NAME = SEE BELOW                                           *
*                                                                     *
*        SOURCE MODULE NAME =  QIP2, ORGINAL VERSION OF SIPC          *
*                                                                     *
*        OBJECT MODULE NAME =  QIP2                                   *
*                                                                     *
*        RELATED MODULE NAME =                                        *
*                                                                     *
*   DESCRIPTIVE NAME = SYSTEM DRVIER FOR TPF 3.2 VIRTUAL              *
*                                                                     *
*   STATUS = VERSION 2  MODIFICATION 3 (POSTING PROGRAM)              *
*                                                                     *
* FUNCTION=                                                           *
*                                                                     *
*  SIPC IS ABLE TO PROVIDE THE FOLLOWING FUNCTIONS:                   *
*                                                                     *
*  1. TO TEST THE IPC PATH BETWEEN ANY TWO PROCESSORS IN A LOOSELY-   *
*     COUPLED ENVIRONMENT.                                            *
*                                                                     *
*  2. TO VERIFY THE SEQUENCE OF BLOCKS SENT VIA A SIPC ARRIVE IN      *
*     CORRECT SEQUENCE.                                               *
*                                                                     *
***********************************************************************
***********************************************************************
* This procedure interprets the error return condition.  It will      *
* post both events to completion.                                     *
*                                                                     *
* Register Conventions:                                               *
*   R3 - Base Address of parameter list, SI3CT                        *
*   R5 - Branching and scratch                                        *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of SI3CT dsect                                     *
*   EBW000 - Start of PARMS dsect                                     *
*   EBX064 - Start of EV0BK dsect for event 1                         *
*   EBX080 - Start of EV0BK dsect for event 2                         *
*                                                                     *
***********************************************************************
         EJECT ,
         CZ1CP                                                 DRV
         LA    R4,EBX000             get addr of si3ct params  @32LCIPC
         SI3CT REG=R4                set up dsect              @32LCIPC
         MVC   EBROUT,ROUTE          we need ebrout
ERROR    DS    0H
         TM    SI3FLGS,SI3RERR       error return?
         BZ    RETURN                no - try return return
         BAS   R5,ERRETURN           write a message
         GETCC D1,L2,FILL=00         allocate LIST block       @32LCIPC
         L     R3,CE1CR1             x                         @32LCIPC
         EV0BK ,                     address block             @32LCIPC
         USING EV0BK,R3              x                         @32LCIPC
         SPACE ,
         GENLC TYPE=CREATE,          create a POST LIST                X
               BLOCK=(R3),                                             X
               DATA=PROCESSOR,                                         X
               INCLUDE=ALL                                     @32LCIPC
         SPACE ,
         CINFC R,CMMIST,F,REG=R1     get IST                  TD00323
         DCTIST REG=R1               IST Dsect                TD00323
         XR    R5,R5                 zero scratch reg         TD00323
         LH    R5,ISTUSEIS           get useable is's         TD00323
         CH    R5,ONE+2              only 1 IS?               TD00323
         BNH   POSTLIST              yes, post list as is      @32LCIPC
         SPACE ,
         CINFC R,CMMPID              get base of PIDT          @32LCIPC
         PI1DT REG=R14               x                         @32LCIPC
         SPACE ,
         LA    R5,PI1CIDN+1          set our proc ord #        @32LCIPC
         LA    R2,1                  set item count = 1        @32LCIPC
         GENLC TYPE=MODIFY,          add us back to list               X
               BLOCK=(R3),                                             X
               DATA=(R5),                                              X
               COUNT=(R2),                                             X
               INCLUDE=ALL
         SPACE ,
POSTLIST DS    0H                                              @32LCIPC
         GETCC D3,L2,FILL=00         allocate 2nd list block   @32LCIPC
         SPACE ,
         L     R2,CE1CR1             base of from block        @32LCIPC
         LH    R3,CE1CC1             len  of from block        @32LCIPC
         L     R14,CE1CR3            base of to block          @32LCIPC
         LR    R15,R3                len  of to block          @32LCIPC
         MVCL  R14,R2                copy block data           @32LCIPC
         SPACE ,
         L     R3,CE1CR1             base of list 1            @32LCIPC
         MVC   EVNBKN,NAME1          move the event name       @32LCIPC
         POSTC TYPE=LIST,            POST event 1                      X
               BLOCK=(R3),                                             X
               NFOUND=NF1,                                             X
               LINFND=LINF1                                    @32LCIPC
         SPACE ,
         B     POST2
NF1      BAS   R5,NOTFOUN1
         B     POST2                                           @32LCIPC
         SPACE ,
LINF1    BAS   R5,LINFND1                                      @32LCIPC
POST2    DS    0H
         L     R3,CE1CR3             base of list 2            @32LCIPC
         MVC   EVNBKN,NAME2          move the event name       @32LCIPC
         POSTC TYPE=LIST,            POST event 1                      X
               BLOCK=(R3),                                             X
               NFOUND=NF2,                                             X
               LINFND=LINF2                                    @32LCIPC
         SPACE ,
         B     EXIT                                            @32LCIPC
NF2      BAS   R5,NOTFOUN2
         B     EXIT                                            @32LCIPC
         SPACE ,
LINF2    BAS   R5,LINFND2                                      @32LCIPC
         SPACE ,
EXIT     DS    0H
         CRUSA S0=1,S1=3             release any list blocks   @32LCIPC
         EXITC ,                                               @32LCIPC
         EJECT ,
***********************************************************************
* This procedure interprets the normal return condition.  It will     *
* post the proper event with the proper processor ordinal number.     *
*                                                                     *
* Register Conventions:                                               *
*   R3 - Base Address of parameter list, SI3CT                        *
*   R5 - Branching and scratch                                        *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of SI3CT dsect                                     *
*   EBW000 - Start of PARMS dsect                                     *
*   EBX064 - Start of EV0BK dsect for event 1                         *
*                                                                     *
***********************************************************************
RETURN   DS    0H
         TM    SI3FLGS,SI3RETD       normal return?
         BZ    NORMAL                no - try sipc return
         CLI   FUNCTEST,X'FF'        write a msg?
         BNE   NOMSG                 no
         BAS   R5,SYSRET             write a message
NOMSG    DS    0H
         GETCC D1,L2,FILL=00         allocate LIST block       @32LCIPC
         L     R3,CE1CR1             point to block            @32LCIPC
         LA    R5,1                  count/size for GENLC      @32LCIPC
         GENLC TYPE=CREATE,          create a POST LIST                X
               BLOCK=(R3),                                             X
               DATA=SI3PROC,                                           X
               COUNT=(R5),                                             X
               SIZE=(R5)                                       @32LCIPC
         SPACE ,
         MVC   EVNBKN,NAME1          move the event name       @32LCIPC
         POSTC TYPE=LIST,            POST event 1                      X
               BLOCK=(R3),                                             X
               NFOUND=NF1A,                                            X
               LINFND=LINF1A                                   @32LCIPC
         B     EXIT                                            @32LCIPC
NF1A     BAS   R5,NOTFOUN1
         B     EXIT                                            @32LCIPC
         SPACE ,
LINF1A   BAS   R5,LINFND1                                      @32LCIPC
         B     EXIT                                            @32LCIPC
         EJECT ,
***********************************************************************
* This procedure interprets the normal return condition.  It will     *
* post the proper event with the proper processor ordinal number.     *
*                                                                     *
* Register Conventions:                                               *
*   R3 - Base Address of parameter list, either PARAMS or SI3CT       *
*   R5 - Branching and scratch                                        *
*                                                                     *
* ECB Conventions:                                                    *
*   EBX000 - Start of SI3CT dsect                                     *
*   EBW000 - Start of PARMS dsect                                     *
*   EBX064 - Start of EV0BK dsect for event 1                         *
*                                                                     *
***********************************************************************
NORMAL   DS    0H
         CLI   FUNCTEST,X'FF'        write a msg?
         BNE   NORITE                no
         BAS   R5,NORMRET            write a message
NORITE   DS    0H
         BAS   R5,CHKBLKS             check data
         GETCC D1,L2,FILL=00         allocate LIST block       @32LCIPC
         L     R3,CE1CR1             point to block            @32LCIPC
         LA    R5,1                  count/size for GENLC      @32LCIPC
         GENLC TYPE=CREATE,          create a POST LIST                X
               BLOCK=(R3),                                             X
               DATA=SI3PROC,                                           X
               COUNT=(R5),                                             X
               SIZE=(R5)                                       @32LCIPC
         SPACE ,
         MVC   EVNBKN,NAME2          move the event name       @32LCIPC
         POSTC TYPE=LIST,            POST event 1                      X
               BLOCK=(R3),                                             X
               NFOUND=NF2A,                                            X
               LINFND=LINF2B                                   @32LCIPC
         B     EXIT                                            @32LCIPC
         SPACE ,
NF2A     BAS   R5,NOTFOUN2
         B     EXIT                                            @32LCIPC
         SPACE ,
LINF2B   BAS   R5,LINFND2                                      @32LCIPC
         B     EXIT                                            @32LCIPC
         EJECT ,
***********************************************************************
* Here are all of the subroutines that are called via a BAS.  They    *
* are maybe grouped in order caller to callee.                        *
***********************************************************************
***********************************************************************
* This will check each blocks' data.                                  *
***********************************************************************
CHKBLKS  DS    0H
         L     R1,CE1CR0        get addr of passed block
         LH    R2,CE1CC0        add count
         AR    R2,R1            copy it
         LA    R1,8(R1)         inc past name3               TD00323
         BAS   R6,FILLIT
         CLI   FUNCTEST,X'FF'   write msg?
         BE    EQUAL            yes
         BR    R5               no
***********************************************************************
* This does the actual checking.                                      *
***********************************************************************
FILLIT   DS    0H
         L     R14,4(R1)        get number in nth+1 byte
         S     R14,0(R1)        subtract number in nth byte
         C     R14,FOUR         is it four
         BNE   NOTEQUAL         not equal - error
         LA    R1,4(R1)         inc to the next fullword
         LR    R7,R2            copy the end point
         SR    R7,R1            sub the end-next fullword
         C     R7,EIGHT         do we have room?
         BL    DONE             no
         B     FILLIT           yes
DONE     DS    0H               quit
         BR    R6
***********************************************************************
* This section contains subroutines that exit via EXITC, and do not   *
* return to any caller.  Basically they are messages.                 *
***********************************************************************
***********************************************************************
* Sets up for a wtopc to notify of normal system retrun               *
***********************************************************************
SYSRET   DS    0H
         LA    R1,SMSG11
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc to notify of data ok.                           *
***********************************************************************
EQUAL    DS    0H
         LA    R1,SMSG12
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc to notify of data not equal.                    *
***********************************************************************
NOTEQUAL DS    0H
         LA    R1,SMSG13
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc to notify of sipc reception.                    *
***********************************************************************
NORMRET  DS    0H
         LA    R1,SMSG14
         B     SUBMSG
***********************************************************************
* Sets up for a WTOPC if error return occurs.                         *
***********************************************************************
ERRETURN DS    0H
         LA    R1,SMSG15
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc if event  not found.                            *
***********************************************************************
NOTFOUN1 DS    0H
         LA    R1,SMSG16
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc if event  not found.                            *
***********************************************************************
NOTFOUN2 DS    0H
         LA    R1,SMSG22
         B     SUBMSG
***********************************************************************
* Sets up for a wtopc if event  list item not found.                  *
***********************************************************************
LINFND1  DS    0H                                              @32LCIPC
         LA    R1,SMSG24                                       @32LCIPC
         B     SUBMSG                                          @32LCIPC
***********************************************************************
* Sets up for a wtopc if event  list item not found.                  *
***********************************************************************
LINFND2  DS    0H                                              @32LCIPC
         LA    R1,SMSG25                                       @32LCIPC
         B     SUBMSG                                          @32LCIPC
***********************************************************************
* For any I,E,W messages.                                             *
***********************************************************************
SUBMSG   DS    0H
         WTOPC TEXTA=(R1),SUB=(CHARA,(CE1CPD,1),CHARA,(EBW023,1)),     X
               ENDOFM=YES,HEADER=NO,MF=(E,EBW032)
         BR    R5
         EJECT ,
***********************************************************************
* All Data is stored here as well as the output messages given all    *
* through this sleigh ride.                                           *
***********************************************************************
ONE      DC    F'1'                                            @32LCIPC
FOUR     DC    F'4'
EIGHT    DC    F'8'
***********************************************************************
* All equates needed are here.                                        *
***********************************************************************
FUNCTEST EQU   EBW000,4
NAME1    EQU   EBW004,8
NAME2    EQU   EBW012,8
ROUTE    EQU   EBW020,4
***********************************************************************
*  Here are messages issued by WTOPC's.                               *
***********************************************************************
SMSG11   EQU   *
         DC    AL1(SMSG11E-SMSG11S)
SMSG11S  DC    C'SIPC0011I SYSTEM RETURN TO .. FROM .. OCCURRED'        d13507
SMSG11E  EQU   *
SMSG12   EQU   *
         DC    AL1(SMSG12E-SMSG12S)
SMSG12S  DC    C'SIPC0012I DATA PASSED TO .. FROM .. IS CORRECT'
SMSG12E  EQU   *
SMSG13   EQU   *
         DC    AL1(SMSG13E-SMSG13S)
SMSG13S  DC    C'SIPC0013E DATA PASSED TO .. FROM .. IS INCORRECT.'
SMSG13E  EQU   *
SMSG14   EQU   *
         DC    AL1(SMSG14E-SMSG14S)
SMSG14S  DC    C'SIPC0014I SIPC RECEIVED ON .. FROM .. OK'
SMSG14E  EQU   *
SMSG15   EQU   *
         DC    AL1(SMSG15E-SMSG15S)
SMSG15S  DC    C'SIPC0015E ERROR RETURN CONDITION HAS OCCURRED.'        d13507
         DC    AL1(#CAR),C'CHECK IF OTHER PROCESSORS IN RESTART STATE.'
SMSG15E  EQU   *
SMSG16   EQU   *
         DC    AL1(SMSG16E-SMSG16S)
SMSG16S  DC    C'SIPC0016E EVENT 1 NOT FOUND'
SMSG16E  EQU   *
SMSG22   EQU   *
         DC    AL1(SMSG22E-SMSG22S)
SMSG22S  DC    C'SIPC0022E EVENT 2 NOT FOUND'
SMSG22E  EQU   *
SMSG24   EQU   *                                               @32LCIPC
         DC    AL1(SMSG24E-SMSG24S)                            @32LCIPC
SMSG24S  DC    C'SIPC0024E EVENT 1 LIST ITEM NOT FOUND'        @32LCIPC
SMSG24E  EQU   *                                               @32LCIPC
SMSG25   EQU   *                                               @32LCIPC
         DC    AL1(SMSG25E-SMSG25S)                            @32LCIPC
SMSG25S  DC    C'SIPC0025E EVENT 2 LIST ITEM NOT FOUND'        @32LCIPC
SMSG25E  EQU   *                                               @32LCIPC
         LTORG
         FINIS QIP2
         END
